          INTEGER FUNCTION IDAMAX(N,DX,INCX)
    *     .. Scalar Arguments ..
          INTEGER INCX,N
    *     ..
    *     .. Array Arguments ..
          DOUBLE PRECISION DX(*)
    *     ..
    *
    *  Purpose
    *  =======
    *
    *     finds the index of element having max. absolute value.
    *     jack dongarra, linpack, 3/11/78.
    *     modified 3/93 to return if incx .le. 0.
    *     modified 12/3/93, array(1) declarations changed to array(*)
    *
    *
    *     .. Local Scalars ..
          DOUBLE PRECISION DMAX
          INTEGER I,IX
    *     ..
    *     .. Intrinsic Functions ..
          INTRINSIC DABS
    *     ..
          IDAMAX = 0
          IF (N.LT.1 .OR. INCX.LE.0) RETURN
          IDAMAX = 1
          IF (N.EQ.1) RETURN
          IF (INCX.EQ.1) GO TO 20
    *
    *        code for increment not equal to 1
    *
          IX = 1
          DMAX = DABS(DX(1))
          IX = IX + INCX
          DO 10 I = 2,N
              IF (DABS(DX(IX)).LE.DMAX) GO TO 5
              IDAMAX = I
              DMAX = DABS(DX(IX))
        5     IX = IX + INCX
       10 CONTINUE
          RETURN
    *
    *        code for increment equal to 1
    *
       20 DMAX = DABS(DX(1))
          DO 30 I = 2,N
              IF (DABS(DX(I)).LE.DMAX) GO TO 30
              IDAMAX = I
              DMAX = DABS(DX(I))
       30 CONTINUE
          RETURN
          END